"""
MIT License

Copyright (c) 2022 ATCode Solutions inc.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
"""

try:  # Python 3.5+
    from collections.abc import Iterable
    from collections.abc import Iterator
except ImportError:  # Python 2.7
    from collections import Iterable
    from collections import Iterator


__all__ = ('EnvIterator',)


class EnvIterator(Iterator):
    """Iterator for environment variables"""

    def __init__(self, variables):
        if not (isinstance(variables, Iterable) and
                not isinstance(variables, str)):
            raise TypeError('Parameter "variables" must be a collection')

        self._variables = variables
        self._generator = (var for var in self._variables)

    def __next__(self):
        return next(self._generator)

    next = __next__  # For Python 2
